routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', 'WelcomeController@index')
    ->name('welcome');

Route::get('/home', function () {
    return redirect('/');
});

Auth::routes();

/*
 * Ramais
*/
$router->group(['prefix' => '/admin', 'middleware' => 'auth'], function ($router) {
    $router->resource('/ramais', 'Admin\\BranchController', [
	    'as' => 'admin',
	])->parameters(['ramais' => 'branch']);

    $router->resource('/informativos', 'Admin\\InformativeController', [
	    'as' => 'admin',
	])->parameters(['informativos' => 'informative']);

    $router->resource('/links', 'Admin\\LinkController', [
	    'as' => 'admin',
	])->parameters(['links' => 'link']);

	$router->resource('/configuracoes', 'Admin\\SettingController', [
        'as' => 'admin',
	])->parameters(['configuracoes' => 'setting']);

    $router->resource('/usuarios', 'Admin\\UserController', [
        'as' => 'admin',
	])->parameters(['usuarios' => 'user'])
        ->only('index', 'edit', 'update');
});

/*
 * Ramais
*/
$router->group(['prefix' => '/ramais'], function ($router) {
    $router->get('/', 'BranchesController@index')
        ->name('branches.branch.index');
});

/*
 * Frequencias
*/
$router->group(['prefix' => '/frequencias'], function ($router) {
    $router->get('/', 'FrequencyController@index')
        ->name('frequencies.frequency.index')
        ->middleware('auth');

    $router->post('/', 'FrequencyController@store')
        ->name('frequencies.frequency.store')
        ->middleware('auth');
});

/*
 * Informativos
*/
$router->group(['prefix' => 'informativos'], function($router) {
    $router->get('/', 'InformativeController@index')
        ->name('informatives.informative.index')
        ->middleware('auth');
});


$router->group(['prefix'=> 'tickets'], function($router) {
    $router->get('/', 'TicketsController@index')
        ->name('tickets.ticket.index');

    $router->post('/', 'TicketsController@send')
        ->name('tickets.ticket.send')
        ->where('sector', '[0-9]+');

    $router->get('/ti', 'TicketsController@ti')
        ->name('tickets.ticket.ti');

    $router->get('/infra', 'TicketsController@infra')
        ->name('tickets.ticket.infra');

});

/*
Route::group(
[
    'prefix' => 'tickets',
], function () {

    Route::get('/', 'TicketsController@index')
      ->name('tickets.ticket.index');

    Route::get('/ti', 'TicketsController@ti')
      ->name('tickets.ticket.ti');

    Route::get('/infra', 'TicketsController@infra')
      ->name('tickets.ticket.infra');

    Route::post('/', 'TicketsController@send')
      ->name('tickets.ticket.send')
      ->where('sector', '[0-9]+');

});
*/

app/Models/Informative.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;

class Informative extends Model
{
    /**
     * The database table used by the model.
     *
     * @var string
     */
    protected $table = 'informatives';

    /**
    * The database primary key value.
    *
    * @var string
    */
    protected $primaryKey = 'id';

    /**
     * Attributes that should be mass-assignable.
     *
     * @var array
     */
    protected $fillable = [
                  'title',
                  'link',
                  'published_at'
              ];

    /**
     * The attributes that should be mutated to dates.
     *
     * @var array
     */
    protected $dates = [];
    
    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
    protected $casts = [];
    


    /**
     * Get created_at in array format
     *
     * @param  string  $value
     * @return array
     */
    public function getCreatedAtAttribute($value)
    {
        return date('j/n/Y g:i A', strtotime($value));
    }

    /**
     * Get updated_at in array format
     *
     * @param  string  $value
     * @return array
     */
    public function getUpdatedAtAttribute($value)
    {
        return date('j/n/Y g:i A', strtotime($value));
    }
}

app/Http/Controllers/Admin/InformativeController.php
<?php

namespace App\Http\Controllers\Admin;

use Carbon\Carbon;
use App\Http\Controllers\Controller;
use App\Models\Informative;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Validator;

class InformativeController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $informatives = Informative::orderBy('published_at', 'ASC')->get();
        return view('admin.informatives.index', compact('informatives'));
        //
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('admin.informatives.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        try
        {
            $aux = Carbon::createFromFormat('d/m/Y', $request->published_at, 'America/Fortaleza');
        } catch (Exception $exception) {
            $aux = Carbon::createFromFormat('Y/m/d h:mm:ss', $request->published_at, 'America/Fortaleza');
        }
        $request->merge(['published_at' => $aux]);

        $validator = $this->validateData($request);

        if ($validator->fails()) {
            return back()
                ->withInput()
                ->withErrors($validator->messages());
        }

        Informative::create($request->all());
        return redirect()->route('admin.informativos.index')
            ->with('success_message', 'Informativo adicionado com sucesso.');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\Informative  $informative
     * @return \Illuminate\Http\Response
     */
    public function show(Informative $informative)
    {
        return view('admin.informatives.show', compact('informative'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\Informative  $informative
     * @return \Illuminate\Http\Response
     */
    public function edit(Informative $informative)
    {
        $informative = Informative::findOrFail($informative->id);
        return view('admin.informatives.edit', compact('informative'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\Informative  $informative
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Informative $informative)
    {
        $validator = $this->validateData($request);

        if ($validator->fails()) {
		    return back()
                ->withInput()
                ->withErrors($validator->messages());
        }

        $informative->update($request->all());

        return redirect()->route('admin.informativos.index')
            ->with('success_message', 'Informativo atualizado com sucesso.');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\Informative  $informative
     * @return \Illuminate\Http\Response
     */
    public function destroy(Informative $informative)
    {
        $informative->delete();
        return redirect()->route('admin.informativos.index')
            ->with('success_message', 'Informativo removido com sucesso.');
    }

    protected function validateData(Request $request)
    {
        $rules = [
            'title' => 'required|string|min:1|max:191',
            'link' => 'required|string|min:1',
            'published_at' => 'required|date',
        ];

        $validator = Validator::make($request->all(), $rules);

        return $validator;
    }

}

app/Http/Controllers/Api/Admin/InformativeController.php
<?php

namespace App\Http\Controllers\Api\Admin;

use Carbon\Carbon;
use App\Http\Controllers\Controller;
use App\Models\Informative;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Validator;

class InformativeController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $informatives = Informative::orderBy('published_at', 'ASC')->get();
        return response()->json($informatives);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        // API doesn't have this method
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $aux = Carbon::parse($request->published_at);
        $request->merge(['published_at' => $aux]);

        $validator = $this->validateData($request);

        if ($validator->fails()) {
            $messages = $validator->errors()->all();
            return response()->json($messages);
        }

        Informative::create($request->all());
        return response()->json(['msg' => 'success']);
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\Informative  $informative
     * @return \Illuminate\Http\Response
     */
    public function show($informative_id)
    {
        // "published_at": "2020-09-07 00:00:00",
        $informative = Informative::where('id', '=', $informative_id)->firstOrFail();
        $aux = Carbon::createFromFormat('Y-m-d H:i:s', $informative->published_at, 'America/Fortaleza');
        $informative->published_at = $aux->toIso8601String();

        return response()->json($informative);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\Informative  $informative
     * @return \Illuminate\Http\Response
     */
    public function edit(Informative $informative)
    {
        // API doesn't have this method
        $informative = Informative::findOrFail($informative->id);
        return view('admin.informatives.edit', compact('informative'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\Informative  $informative
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Informative $informative)
    {

        $aux = Carbon::parse($request->published_at);
        $request->merge(['published_at' => $aux]);

        $validator = $this->validateData($request);

        if ($validator->fails()) {
            $messages = $validator->errors()->all();
            return response()->json($messages);
        }

        $informative->update($request->all());
        return response()->json($informative);
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\Informative  $informative
     * @return \Illuminate\Http\Response
     */
    public function destroy(Informative $informative)
    {
        $informative->delete();
        return response()->json($informative);
    }

    protected function validateData(Request $request)
    {
        $rules = [
            'title' => 'required|string|min:1|max:191',
            'link' => 'required|string|min:1',
            'published_at' => 'required|date',
        ];

        $validator = Validator::make($request->all(), $rules);

        return $validator;
    }

}

app/Http/Controllers/Api/InformativeController.php
<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use App\Models\Informative;
use Illuminate\Http\Request;

class InformativeController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $informatives = Informative::orderBy('published_at', 'DESC')->get();
        return response()->json($informatives);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\Informative  $informative
     * @return \Illuminate\Http\Response
     */
    public function show(Informative $informative)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\Informative  $informative
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Informative $informative)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\Informative  $informative
     * @return \Illuminate\Http\Response
     */
    public function destroy(Informative $informative)
    {
        //
    }
}

app/Http/Controllers/InformativeController.php
<?php

namespace App\Http\Controllers;

use App\Models\Informative;
use Illuminate\Http\Request;

class InformativeController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $informatives = Informative::orderBy('published_at', 'DESC')->get();
        return view('informatives.index', compact('informatives'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Informative  $informative
     * @return \Illuminate\Http\Response
     */
    public function show(Informative $informative)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Informative  $informative
     * @return \Illuminate\Http\Response
     */
    public function edit(Informative $informative)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Informative  $informative
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Informative $informative)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Informative  $informative
     * @return \Illuminate\Http\Response
     */
    public function destroy(Informative $informative)
    {
        //
    }
}

resources/views/admin/informatives/create.blade.php
@extends('layouts.modules')

@section('content')

<div class="section">
  <div class="container">
    <div class="columns is-centered">
      <div class="column is-half">
      <div class="box">
        <h2 class="title">Cadastrar novo informativo</h2>
        @if ($errors->any())
        <div class="notification">
          <h4 class="title">Verifique se o formulário está correto</h4>
          <ul>
            @foreach ($errors->all() as $error)
              <li>{{ $error }}</li>
            @endforeach
          </ul>
        </div>
        @endif

        <form method="POST" action="{{ route('admin.informativos.store') }}" accept-charset="UTF-8" id="create_informative_form" name="create_informative_form">
          {{ csrf_field() }}
          @include ('admin.informatives.form', ['informative' => null])

          <div class="control">
            <a class="button button-default" href="javascript:history.back()">Voltar</a>
            <input class="button is-primary" type="submit" value="Adicionar">
          </div>

        </form>

      </div>
      </div>
    </div>
  </div>
</div>

@endsection

resources/views/admin/informatives/edit.blade.php
@extends('layouts.modules')

@section('content')

<div class="section">
  <div class="container">
    <div class="columns is-centered">
      <div class="column is-half">
      <div class="box">
        <h2 class="title">Editar informativo</h2>
        @if ($errors->any())
          <div class="notification is-danger">
            <h4 class="title">Verifique se o formulário está correto</h4>
            <ul>
              @foreach ($errors->all() as $error)
                <li>{{ $error }}</li>
              @endforeach
            </ul>
          </div>
        @endif

        <form method="POST" action="{{ route('admin.informativos.update', $informative) }}" id="edit_informative_form" name="edit_informative_form" accept-charset="UTF-8" >
          {{ csrf_field() }}
          <input name="_method" type="hidden" value="PUT">
          @include ('admin.informatives.form', ['informative' => $informative])

          <div class="control">
            <a class="button button-default" href="javascript:history.back()">Voltar</a>
            <input class="button is-primary" type="submit" value="Atualizar">
          </div>

        </form>
      </div>
      </div>
    </div>
  </div>
</div>

@endsection

resources/views/admin/informatives/form.blade.php
<div class="columns">
  <div class="column">

    <div class="field">
      <label class="label" for="published_at">Data de publicação</label>
      <div class="control">
        <input class="input {{ $errors->has('published_at') ? 'is-danger' : '' }}" name="published_at" type="text" id="sector" value="{{ old('published_at', optional($informative)->published_at) }}" minlength="1" maxlength="30" required="true" placeholder="Data do informativo">
        {!! $errors->first('published_at', '<p class="is-small is-danger">:message</p>') !!}
      </div>
    </div>

    <div class="field">
      <label class="label" for="title">Título</label>
      <div class="control">
        <input class="input {{ $errors->has('title') ? 'is-danger' : '' }}" name="title" type="text" id="title" value="{{ old('title', optional($informative)->title) }}" minlength="10" maxlength="30" required="true" placeholder="Título">
        {!! $errors->first('sector', '<p class="is-small is-danger">:message</p>') !!}
      </div>
    </div>

    <div class="field">
      <label class="label" for="link">Link</label>
      <div class="control">
        <input class="input {{ $errors->has('link') ? 'is-danger' : '' }}" name="link" type="text" id="link" value="{{ old('link', optional($informative)->link) }}" minlength="1" required="true" placeholder="Link">
        {!! $errors->first('sector', '<p class="is-small is-danger">:message</p>') !!}
      </div>
    </div>

  </div>
</div>

resources/views/admin/informatives/index.blade.php
@extends('layouts.modules')

@section('content')

<div class="section">
  <div class="container">
    <div class="">
      <div class="box">

        <div id="notification" class="notification is-success is-light is-hidden">
            {{ session('success_message') }}
        </div>

        <h2 class="title">Informativos</h2>
        <p><a class="button is-info" href="{{ route('admin.informativos.create') }}">Adicionar novo informativo</a></p>

        <table class="table table-striped is-fullwidth is-hoverable">
          <thead>
            <tr>
              <th>Data da publicação</th>
              <th>Título</th>
              <th>Link</th>
              <th>Ações</th>
            </tr>
          </thead>
          <tbody>
          @foreach ($informatives as $informative)
            <tr>

              <td>{{ date('d/m/Y', strtotime($informative->published_at)) }}</td>
              <td>{{ $informative->title }}</td>
              <td><a href="{{ $informative->link }}">{{ $informative->link }}</a></td>
              <td>
                <a href="{{ route('admin.informativos.edit', $informative ) }}" class="button is-white is-text">
                  <span class="icon">
                    <i class="mdi mdi-pencil"></i>
                  </span>
                </a>

                <form id="informative-form" class="is-pulled-left" name="deleteInformativeForm" method="POST" action="{!! route('admin.informativos.destroy', $informative) !!}" accept-charset="UTF-8">
                    <input name="_method" value="DELETE" type="hidden">
                    {{ csrf_field() }}
                    <button class="button is-white is-text" type="submit">
                        <span class="icon">
                            <i class="mdi mdi-delete"></i>
                        </span>
                    </button>
                </form>
              </td>
            </tr>
          @endforeach
          </tbody>
        </table>

        <a class="button button-default" href="javascript:history.back()">Voltar</a>


      </div>
    </div>
  </div> <!-- container -->
</div> <!-- /section -->
@endsection

@section('jscontent')
  <script>
  @if(Session::has('success_message'))
    var notification = document.getElementById('notification');
    notification.classList.remove('is-hidden');
    setTimeout(function(){ notification.classList.add('is-hidden'); }, 5000);
  @endif
  </script>
@endsection